Leetcode kSum问题

kSum 泛指一类问题,例如 leetcode 第1题 2 Sumleetcode 第15题 3 Sumleetcode 第18题 4 Sum

我们先一题一题来看,然后总结出这一类题目的解题套路。

2Sum(leetcode 第1题)

问题

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

两层for循环解法(O(N^2))

public int[] twoSum(int[] nums, int target) {
    int[] res = new int[2];
    for (int i = 0; i < nums.length; i++) {
        for (int j = i + 1; j < nums.length; j++) {
            if (nums[i] + nums[j] == target) {
                res[0] = i;
                res[1] = j;
                return res;
            }
        }
    }
    return res;
}

时间复杂度:O(N^2)

这种解法最简单直观,但是效率也是最低的。如果提交的话无法通过所有 test case,肯定会超时。

排序+two pointers(O(NlogN))

先排序,然后再使用 two pointers:

public int[] twoSum(int[] nums, int target) {
    Arrays.sort(nums);
    int i = 0, j = nums.length - 1;
    int[] res = new int[2];
    while (i < j) {
        if (nums[i] + nums[j] == target) {
            res[0] = i;
            res[1] = j;
            break;
        } else if (nums[i] + nums[j] < target) {
            i++;
        } else {
            j--;
        }
    }
    return res;
}

时间复杂度:O(Nlog(N)) + O(N),最后复杂度为O(Nlog(N))

HashMap一遍遍历(O(N))

public int[] twoSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
        map.put(nums[i], i);
    }
    int j = 0, k = 0;
    for (int i = 0; i < nums.length; i++) {
        int left = target - nums[i];
        if (map.containsKey(left) && i != map.get(left)) {
            j = i;
            k = map.get(left);
            break;
        }
    }
    int[] res = new int[2];
    res[0] = j;
    res[1] = k;
    return res;
}

时间复杂度:O(N)

3Sum(leetcode 第5题)

问题

Given an array nums of n integers, are there elements a, b, c in nums such that a + b + c = 0? Find all unique triplets in the array which gives the sum of zero.

Note:

The solution set must not contain duplicate triplets.

Example:

Given array nums = [-1, 0, 1, 2, -1, -4],

A solution set is:
[
  [-1, 0, 1],
  [-1, -1, 2]
]

排序+ two pointers

3Sum 和 2Sum 类似,前面介绍的 2Sum 的前两种解法对 3Sum一样有效。第一种解法通过三层 for 循环肯定会超时。因此我们还是先排序,然后再用 two pointers 来解题:

public List<List<Integer>> threeSum(int[] nums) {
    if (nums == null || nums.length < 3) {
        return new ArrayList<>();
    }
    List<List<Integer>> ret = new ArrayList<>();
    Arrays.sort(nums);
    for (int i = 0; i < nums.length - 2; i++) {
        int num = nums[i];
        if (i > 0 && nums[i] == nums[i - 1]) {
            continue;
        }
        bSearch(nums, i + 1, nums.length - 1, -num, ret, i);
    }
    return ret;
}

private void bSearch(int[] nums, int start, int end, int targetTotal, List<List<Integer>> ret, int index) {
    int i = start, j = end;
    while (i < j) {
        if (targetTotal == nums[i] + nums[j]) {
            List<Integer> oneShot = new ArrayList<>();
            oneShot.add(nums[index]);
            oneShot.add(nums[i]);
            oneShot.add(nums[j]);
            ret.add(oneShot);
            // 题目要求结果返回的 triple 都是唯一的,因此这里需要跳过前后相同的元素
            while (i < j && nums[i] == nums[i + 1]) {
                i++;
            }
            while (i < j && nums[j] == nums[j - 1]) {
                j--;
            }
            i++;
            j--;
        } else if (nums[i] + nums[j] > targetTotal) {
            j--;
        } else {
            i++;
        }
    }
}

时间复杂度:O(NlogN) + O(N2),最终复杂度为O(N2)

4Sum(leetcode 第18题)

问题

Given an array nums of n integers and an integer target, are there elements a, b, c, and d in nums such that a + b + c + d = target? Find all unique quadruplets in the array which gives the sum of target.

Note:

The solution set must not contain duplicate quadruplets.

Example:

Given array nums = [1, 0, -1, 0, -2, 2], and target = 0.

A solution set is:
[
  [-1,  0, 0, 1],
  [-2, -1, 1, 2],
  [-2,  0, 0, 2]
]

分析

在解 3Sum 题的时候我们先固定了一个数num,然后再在剩余的数组元素中利用 two pointers 方法寻找和为 target - num的两个数。

归纳分析,我们可以将 kSum 一类的问题的解法分为两个步骤:

  1. 将 kSum 问题转换成 2Sum 问题
  2. 解决 2Sum 问题

给出 kSum 一类问题的一般解法如下:

/**
 * All kSum problem can be divided to two parts:
 * 1: convert kSum to 2Sum problem;
 * 2: solve the 2Sum problem;
 *
 * @param k
 * @param index
 * @param nums
 * @param target
 * @return
 */
private List<List<Integer>> kSum(int k, int index, int[] nums, int target) {
    List<List<Integer>> res = new ArrayList<>();
    int len = nums.length;
    if (k == 2) {
        // 使用 two pointers 解决 2Sum 问题
        int left = index, right = len - 1;
        while (left < right) {
            int sum = nums[left] + nums[right];
            if (sum == target) {
                List<Integer> path = new ArrayList<>();
                path.add(nums[left]);
                path.add(nums[right]);
                res.add(path);
                // skip the duplicates
                while (left < right && nums[left] == nums[left + 1]) {
                    left++;
                }
                while (left < right && nums[right] == nums[right - 1]) {
                    right--;
                }
                left++;
                right--;
            } else if (sum > target) {
                right--;
            } else {
                left++;
            }
        }
    } else {
        // 将 kSum 问题转换为 2Sum 问题
        for (int i = index; i < len - k + 1; i++) {
            // 跳过重复的元素
            if (i > index && nums[i] == nums[i - 1]) {
                continue;
            }
            // 固定一个元素,然后递归
            List<List<Integer>> kSubtractOneSum = kSum(k - 1, i + 1, nums, target - nums[i]);
            if (kSubtractOneSum != null) {
                for (List<Integer> path : kSubtractOneSum) {
                    path.add(0, nums[i]); // 将固定的元素加入路径中
                }
                res.addAll(kSubtractOneSum);
            }
        }
    }
    return res;
}

解决了 kSum问题之后,4Sum 问题的解法就很简单了:

public List<List<Integer>> fourSum(int[] nums, int target) {
    if (nums == null || nums.length < 4) {
        return new ArrayList<>();
    }
    Arrays.sort(nums);
    return kSum(4, 0, nums, target);
}

时间复杂度:O(N^3)。

最后编辑于
©著作权归作者所有,转载或内容合作请联系作者
  • 序言:七十年代末,一起剥皮案震惊了整个滨河市,随后出现的几起案子,更是在滨河造成了极大的恐慌,老刑警刘岩,带你破解...
    沈念sama阅读 203,456评论 5 477
  • 序言:滨河连续发生了三起死亡事件,死亡现场离奇诡异,居然都是意外死亡,警方通过查阅死者的电脑和手机,发现死者居然都...
    沈念sama阅读 85,370评论 2 381
  • 文/潘晓璐 我一进店门,熙熙楼的掌柜王于贵愁眉苦脸地迎上来,“玉大人,你说我怎么就摊上这事。” “怎么了?”我有些...
    开封第一讲书人阅读 150,337评论 0 337
  • 文/不坏的土叔 我叫张陵,是天一观的道长。 经常有香客问我,道长,这世上最难降的妖魔是什么? 我笑而不...
    开封第一讲书人阅读 54,583评论 1 273
  • 正文 为了忘掉前任,我火速办了婚礼,结果婚礼上,老公的妹妹穿的比我还像新娘。我一直安慰自己,他们只是感情好,可当我...
    茶点故事阅读 63,596评论 5 365
  • 文/花漫 我一把揭开白布。 她就那样静静地躺着,像睡着了一般。 火红的嫁衣衬着肌肤如雪。 梳的纹丝不乱的头发上,一...
    开封第一讲书人阅读 48,572评论 1 281
  • 那天,我揣着相机与录音,去河边找鬼。 笑死,一个胖子当着我的面吹牛,可吹牛的内容都是我干的。 我是一名探鬼主播,决...
    沈念sama阅读 37,936评论 3 395
  • 文/苍兰香墨 我猛地睁开眼,长吁一口气:“原来是场噩梦啊……” “哼!你这毒妇竟也来了?” 一声冷哼从身侧响起,我...
    开封第一讲书人阅读 36,595评论 0 258
  • 序言:老挝万荣一对情侣失踪,失踪者是张志新(化名)和其女友刘颖,没想到半个月后,有当地人在树林里发现了一具尸体,经...
    沈念sama阅读 40,850评论 1 297
  • 正文 独居荒郊野岭守林人离奇死亡,尸身上长有42处带血的脓包…… 初始之章·张勋 以下内容为张勋视角 年9月15日...
    茶点故事阅读 35,601评论 2 321
  • 正文 我和宋清朗相恋三年,在试婚纱的时候发现自己被绿了。 大学时的朋友给我发了我未婚夫和他白月光在一起吃饭的照片。...
    茶点故事阅读 37,685评论 1 329
  • 序言:一个原本活蹦乱跳的男人离奇死亡,死状恐怖,灵堂内的尸体忽然破棺而出,到底是诈尸还是另有隐情,我是刑警宁泽,带...
    沈念sama阅读 33,371评论 4 318
  • 正文 年R本政府宣布,位于F岛的核电站,受9级特大地震影响,放射性物质发生泄漏。R本人自食恶果不足惜,却给世界环境...
    茶点故事阅读 38,951评论 3 307
  • 文/蒙蒙 一、第九天 我趴在偏房一处隐蔽的房顶上张望。 院中可真热闹,春花似锦、人声如沸。这庄子的主人今日做“春日...
    开封第一讲书人阅读 29,934评论 0 19
  • 文/苍兰香墨 我抬头看了看天上的太阳。三九已至,却和暖如春,着一层夹袄步出监牢的瞬间,已是汗流浃背。 一阵脚步声响...
    开封第一讲书人阅读 31,167评论 1 259
  • 我被黑心中介骗来泰国打工, 没想到刚下飞机就差点儿被人妖公主榨干…… 1. 我叫王不留,地道东北人。 一个月前我还...
    沈念sama阅读 43,636评论 2 349
  • 正文 我出身青楼,却偏偏与公主长得像,于是被迫代替她去往敌国和亲。 传闻我的和亲对象是个残疾皇子,可洞房花烛夜当晚...
    茶点故事阅读 42,411评论 2 342